Subject: Re: [Bitcoin-development] Supermajority mining votes for valid->invalid changes.

From: "Luke-Jr" <[email-masked]>
Date: Mon, 3 Oct 2011 01:32:19 -0400

On Monday, October 03, 2011 12:53:51 AM Gregory Maxwell wrote:
> Upgraded nodes get the following rules:
> (0) Never forward or mine a txn which would be invalid under the new rule.
> (1) Apply old behavior before height X unconditionally.
>     (X set far enough in the future to get reasonable deployment by
> large miners)
> (2) Begin applying the new rule only after the first point in the chain
>     after X when none of the last Y blocks have contained an invalid
> transaction under the new rules.

Perhaps as a safeguard:
(3) Before applying the new rule, require 50% of the last Y blocks contain a
    coinbase with a "I am upgraded" code
(4) Until the new rule is active, include an "I am upgraded" code in every
    block; after it's active, this can be turned off

> After the software has been released members of the bitcoin community then
> begin _intentionally_ transmitting transactions which are invalid under
> the new rules. (What would have been an attack under simplest deployment
> plan)

Why would legitimate community members ever intentionally transmit an invalid 
transaction? ;)